# coding: utf-8

"""
    Diveplane API

    OpenAPI implementation for interacting with the Diveplane API.   # noqa: E501

    The version of the OpenAPI document: 23.7.1
    Contact: diveplane@diveplane.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from diveplane.openapi.configuration import Configuration


class Account(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'uuid': 'str',
        'username': 'str',
        'first_name': 'str',
        'last_name': 'str',
        'email': 'str',
        'default_project': 'ProjectIdentity'
    }

    attribute_map = {
        'uuid': 'uuid',
        'username': 'username',
        'first_name': 'first_name',
        'last_name': 'last_name',
        'email': 'email',
        'default_project': 'default_project'
    }

    nullable_attributes = [
    ]

    discriminator = None

    def __init__(self, uuid=None, username=None, first_name=None, last_name=None, email=None, default_project=None, local_vars_configuration=None):  # noqa: E501
        """Account - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._uuid = None
        self._username = None
        self._first_name = None
        self._last_name = None
        self._email = None
        self._default_project = None

        if uuid is not None:
            self.uuid = uuid
        if username is not None:
            self.username = username
        if first_name is not None:
            self.first_name = first_name
        if last_name is not None:
            self.last_name = last_name
        if email is not None:
            self.email = email
        if default_project is not None:
            self.default_project = default_project

    @property
    def uuid(self):
        """Gets the uuid of this Account.  # noqa: E501

        The user's UUID.  # noqa: E501

        :return: The uuid of this Account.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this Account.

        The user's UUID.  # noqa: E501

        :param uuid: The uuid of this Account.  # noqa: E501
        :type uuid: str
        """

        self._uuid = uuid

    @property
    def username(self):
        """Gets the username of this Account.  # noqa: E501

        The user's username.  # noqa: E501

        :return: The username of this Account.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this Account.

        The user's username.  # noqa: E501

        :param username: The username of this Account.  # noqa: E501
        :type username: str
        """

        self._username = username

    @property
    def first_name(self):
        """Gets the first_name of this Account.  # noqa: E501

        The user's first name.  # noqa: E501

        :return: The first_name of this Account.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this Account.

        The user's first name.  # noqa: E501

        :param first_name: The first_name of this Account.  # noqa: E501
        :type first_name: str
        """

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this Account.  # noqa: E501

        The user's last name.  # noqa: E501

        :return: The last_name of this Account.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this Account.

        The user's last name.  # noqa: E501

        :param last_name: The last_name of this Account.  # noqa: E501
        :type last_name: str
        """

        self._last_name = last_name

    @property
    def email(self):
        """Gets the email of this Account.  # noqa: E501

        THe user's email address.  # noqa: E501

        :return: The email of this Account.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this Account.

        THe user's email address.  # noqa: E501

        :param email: The email of this Account.  # noqa: E501
        :type email: str
        """

        self._email = email

    @property
    def default_project(self):
        """Gets the default_project of this Account.  # noqa: E501


        :return: The default_project of this Account.  # noqa: E501
        :rtype: ProjectIdentity
        """
        return self._default_project

    @default_project.setter
    def default_project(self, default_project):
        """Sets the default_project of this Account.


        :param default_project: The default_project of this Account.  # noqa: E501
        :type default_project: ProjectIdentity
        """

        self._default_project = default_project

    def to_dict(self, serialize=False, exclude_null=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                elif 'exclude_null' in args:
                    return x.to_dict(serialize, exclude_null)
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            elif value is None and (exclude_null or attr not in self.nullable_attributes):
                continue
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Account):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Account):
            return True

        return self.to_dict() != other.to_dict()
