# coding: utf-8

"""
    Diveplane API

    OpenAPI implementation for interacting with the Diveplane API.   # noqa: E501

    The version of the OpenAPI document: 23.7.1
    Contact: diveplane@diveplane.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from diveplane.openapi.configuration import Configuration


class AppendToSeriesStoreRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'series': 'str',
        'contexts': 'list[list[object]]',
        'context_features': 'list[str]'
    }

    attribute_map = {
        'series': 'series',
        'contexts': 'contexts',
        'context_features': 'context_features'
    }

    nullable_attributes = [
    ]

    discriminator = None

    def __init__(self, series=None, contexts=None, context_features=None, local_vars_configuration=None):  # noqa: E501
        """AppendToSeriesStoreRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._series = None
        self._contexts = None
        self._context_features = None

        self.series = series
        self.contexts = contexts
        self.context_features = context_features

    @property
    def series(self):
        """Gets the series of this AppendToSeriesStoreRequest.  # noqa: E501

        The name of the series store to append to.  # noqa: E501

        :return: The series of this AppendToSeriesStoreRequest.  # noqa: E501
        :rtype: str
        """
        return self._series

    @series.setter
    def series(self, series):
        """Sets the series of this AppendToSeriesStoreRequest.

        The name of the series store to append to.  # noqa: E501

        :param series: The series of this AppendToSeriesStoreRequest.  # noqa: E501
        :type series: str
        """
        if self.local_vars_configuration.client_side_validation and series is None:  # noqa: E501
            raise ValueError("Invalid value for `series`, must not be `None`")  # noqa: E501

        self._series = series

    @property
    def contexts(self):
        """Gets the contexts of this AppendToSeriesStoreRequest.  # noqa: E501

        An array of case values.  These values correspond to the context Features of the Trainee.   # noqa: E501

        :return: The contexts of this AppendToSeriesStoreRequest.  # noqa: E501
        :rtype: list[list[object]]
        """
        return self._contexts

    @contexts.setter
    def contexts(self, contexts):
        """Sets the contexts of this AppendToSeriesStoreRequest.

        An array of case values.  These values correspond to the context Features of the Trainee.   # noqa: E501

        :param contexts: The contexts of this AppendToSeriesStoreRequest.  # noqa: E501
        :type contexts: list[list[object]]
        """
        if self.local_vars_configuration.client_side_validation and contexts is None:  # noqa: E501
            raise ValueError("Invalid value for `contexts`, must not be `None`")  # noqa: E501

        self._contexts = contexts

    @property
    def context_features(self):
        """Gets the context_features of this AppendToSeriesStoreRequest.  # noqa: E501

        The context feature names.  # noqa: E501

        :return: The context_features of this AppendToSeriesStoreRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._context_features

    @context_features.setter
    def context_features(self, context_features):
        """Sets the context_features of this AppendToSeriesStoreRequest.

        The context feature names.  # noqa: E501

        :param context_features: The context_features of this AppendToSeriesStoreRequest.  # noqa: E501
        :type context_features: list[str]
        """
        if self.local_vars_configuration.client_side_validation and context_features is None:  # noqa: E501
            raise ValueError("Invalid value for `context_features`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                context_features is not None and len(context_features) < 1):
            raise ValueError("Invalid value for `context_features`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._context_features = context_features

    def to_dict(self, serialize=False, exclude_null=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                elif 'exclude_null' in args:
                    return x.to_dict(serialize, exclude_null)
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            elif value is None and (exclude_null or attr not in self.nullable_attributes):
                continue
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppendToSeriesStoreRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppendToSeriesStoreRequest):
            return True

        return self.to_dict() != other.to_dict()
