# coding: utf-8

"""
    Diveplane API

    OpenAPI implementation for interacting with the Diveplane API.   # noqa: E501

    The version of the OpenAPI document: 23.7.1
    Contact: diveplane@diveplane.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from diveplane.openapi.configuration import Configuration


class IntegerType(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data_type': 'str',
        'size': 'int',
        'unsigned': 'bool'
    }

    attribute_map = {
        'data_type': 'data_type',
        'size': 'size',
        'unsigned': 'unsigned'
    }

    nullable_attributes = [
    ]

    discriminator = None

    def __init__(self, data_type=None, size=None, unsigned=False, local_vars_configuration=None):  # noqa: E501
        """IntegerType - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._data_type = None
        self._size = None
        self._unsigned = None

        self.data_type = data_type
        if size is not None:
            self.size = size
        if unsigned is not None:
            self.unsigned = unsigned

    @property
    def data_type(self):
        """Gets the data_type of this IntegerType.  # noqa: E501

        The name of the data type.  # noqa: E501

        :return: The data_type of this IntegerType.  # noqa: E501
        :rtype: str
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this IntegerType.

        The name of the data type.  # noqa: E501

        :param data_type: The data_type of this IntegerType.  # noqa: E501
        :type data_type: str
        """
        if self.local_vars_configuration.client_side_validation and data_type is None:  # noqa: E501
            raise ValueError("Invalid value for `data_type`, must not be `None`")  # noqa: E501

        self._data_type = data_type

    @property
    def size(self):
        """Gets the size of this IntegerType.  # noqa: E501

        The size of the integer (in bytes).  # noqa: E501

        :return: The size of this IntegerType.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this IntegerType.

        The size of the integer (in bytes).  # noqa: E501

        :param size: The size of this IntegerType.  # noqa: E501
        :type size: int
        """

        self._size = size

    @property
    def unsigned(self):
        """Gets the unsigned of this IntegerType.  # noqa: E501

        If the integer is unsigned.  # noqa: E501

        :return: The unsigned of this IntegerType.  # noqa: E501
        :rtype: bool
        """
        return self._unsigned

    @unsigned.setter
    def unsigned(self, unsigned):
        """Sets the unsigned of this IntegerType.

        If the integer is unsigned.  # noqa: E501

        :param unsigned: The unsigned of this IntegerType.  # noqa: E501
        :type unsigned: bool
        """

        self._unsigned = unsigned

    def to_dict(self, serialize=False, exclude_null=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                elif 'exclude_null' in args:
                    return x.to_dict(serialize, exclude_null)
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            elif value is None and (exclude_null or attr not in self.nullable_attributes):
                continue
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IntegerType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IntegerType):
            return True

        return self.to_dict() != other.to_dict()
