# coding: utf-8

"""
    Diveplane API

    OpenAPI implementation for interacting with the Diveplane API.   # noqa: E501

    The version of the OpenAPI document: 23.7.1
    Contact: diveplane@diveplane.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from diveplane.openapi.configuration import Configuration


class ReactIntoFeaturesRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'features': 'list[str]',
        'familiarity_conviction_addition': 'str',
        'familiarity_conviction_removal': 'str',
        'p_value_of_addition': 'str',
        'p_value_of_removal': 'str',
        'distance_contribution': 'str',
        'high_distance_accuracy': 'bool',
        'use_case_weights': 'bool',
        'weight_feature': 'str'
    }

    attribute_map = {
        'features': 'features',
        'familiarity_conviction_addition': 'familiarity_conviction_addition',
        'familiarity_conviction_removal': 'familiarity_conviction_removal',
        'p_value_of_addition': 'p_value_of_addition',
        'p_value_of_removal': 'p_value_of_removal',
        'distance_contribution': 'distance_contribution',
        'high_distance_accuracy': 'high_distance_accuracy',
        'use_case_weights': 'use_case_weights',
        'weight_feature': 'weight_feature'
    }

    nullable_attributes = [
    ]

    discriminator = None

    def __init__(self, features=None, familiarity_conviction_addition=None, familiarity_conviction_removal=None, p_value_of_addition=None, p_value_of_removal=None, distance_contribution=None, high_distance_accuracy=None, use_case_weights=None, weight_feature=None, local_vars_configuration=None):  # noqa: E501
        """ReactIntoFeaturesRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._features = None
        self._familiarity_conviction_addition = None
        self._familiarity_conviction_removal = None
        self._p_value_of_addition = None
        self._p_value_of_removal = None
        self._distance_contribution = None
        self._high_distance_accuracy = None
        self._use_case_weights = None
        self._weight_feature = None

        if features is not None:
            self.features = features
        if familiarity_conviction_addition is not None:
            self.familiarity_conviction_addition = familiarity_conviction_addition
        if familiarity_conviction_removal is not None:
            self.familiarity_conviction_removal = familiarity_conviction_removal
        if p_value_of_addition is not None:
            self.p_value_of_addition = p_value_of_addition
        if p_value_of_removal is not None:
            self.p_value_of_removal = p_value_of_removal
        if distance_contribution is not None:
            self.distance_contribution = distance_contribution
        if high_distance_accuracy is not None:
            self.high_distance_accuracy = high_distance_accuracy
        if use_case_weights is not None:
            self.use_case_weights = use_case_weights
        if weight_feature is not None:
            self.weight_feature = weight_feature

    @property
    def features(self):
        """Gets the features of this ReactIntoFeaturesRequest.  # noqa: E501

        The features to use when calculating convictions.  # noqa: E501

        :return: The features of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._features

    @features.setter
    def features(self, features):
        """Sets the features of this ReactIntoFeaturesRequest.

        The features to use when calculating convictions.  # noqa: E501

        :param features: The features of this ReactIntoFeaturesRequest.  # noqa: E501
        :type features: list[str]
        """

        self._features = features

    @property
    def familiarity_conviction_addition(self):
        """Gets the familiarity_conviction_addition of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature to store conviction of addition values.  # noqa: E501

        :return: The familiarity_conviction_addition of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._familiarity_conviction_addition

    @familiarity_conviction_addition.setter
    def familiarity_conviction_addition(self, familiarity_conviction_addition):
        """Sets the familiarity_conviction_addition of this ReactIntoFeaturesRequest.

        The name of the feature to store conviction of addition values.  # noqa: E501

        :param familiarity_conviction_addition: The familiarity_conviction_addition of this ReactIntoFeaturesRequest.  # noqa: E501
        :type familiarity_conviction_addition: str
        """

        self._familiarity_conviction_addition = familiarity_conviction_addition

    @property
    def familiarity_conviction_removal(self):
        """Gets the familiarity_conviction_removal of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature to store conviction of removal values.  # noqa: E501

        :return: The familiarity_conviction_removal of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._familiarity_conviction_removal

    @familiarity_conviction_removal.setter
    def familiarity_conviction_removal(self, familiarity_conviction_removal):
        """Sets the familiarity_conviction_removal of this ReactIntoFeaturesRequest.

        The name of the feature to store conviction of removal values.  # noqa: E501

        :param familiarity_conviction_removal: The familiarity_conviction_removal of this ReactIntoFeaturesRequest.  # noqa: E501
        :type familiarity_conviction_removal: str
        """

        self._familiarity_conviction_removal = familiarity_conviction_removal

    @property
    def p_value_of_addition(self):
        """Gets the p_value_of_addition of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature to store p value of addition values.  # noqa: E501

        :return: The p_value_of_addition of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._p_value_of_addition

    @p_value_of_addition.setter
    def p_value_of_addition(self, p_value_of_addition):
        """Sets the p_value_of_addition of this ReactIntoFeaturesRequest.

        The name of the feature to store p value of addition values.  # noqa: E501

        :param p_value_of_addition: The p_value_of_addition of this ReactIntoFeaturesRequest.  # noqa: E501
        :type p_value_of_addition: str
        """

        self._p_value_of_addition = p_value_of_addition

    @property
    def p_value_of_removal(self):
        """Gets the p_value_of_removal of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature to store p value of removal values.  # noqa: E501

        :return: The p_value_of_removal of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._p_value_of_removal

    @p_value_of_removal.setter
    def p_value_of_removal(self, p_value_of_removal):
        """Sets the p_value_of_removal of this ReactIntoFeaturesRequest.

        The name of the feature to store p value of removal values.  # noqa: E501

        :param p_value_of_removal: The p_value_of_removal of this ReactIntoFeaturesRequest.  # noqa: E501
        :type p_value_of_removal: str
        """

        self._p_value_of_removal = p_value_of_removal

    @property
    def distance_contribution(self):
        """Gets the distance_contribution of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature to store distance contribution ratios for each case.  # noqa: E501

        :return: The distance_contribution of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._distance_contribution

    @distance_contribution.setter
    def distance_contribution(self, distance_contribution):
        """Sets the distance_contribution of this ReactIntoFeaturesRequest.

        The name of the feature to store distance contribution ratios for each case.  # noqa: E501

        :param distance_contribution: The distance_contribution of this ReactIntoFeaturesRequest.  # noqa: E501
        :type distance_contribution: str
        """

        self._distance_contribution = distance_contribution

    @property
    def high_distance_accuracy(self):
        """Gets the high_distance_accuracy of this ReactIntoFeaturesRequest.  # noqa: E501

        When true, uses high accuracy when computing distances. Otherwise uses low accuracy.  # noqa: E501

        :return: The high_distance_accuracy of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: bool
        """
        return self._high_distance_accuracy

    @high_distance_accuracy.setter
    def high_distance_accuracy(self, high_distance_accuracy):
        """Sets the high_distance_accuracy of this ReactIntoFeaturesRequest.

        When true, uses high accuracy when computing distances. Otherwise uses low accuracy.  # noqa: E501

        :param high_distance_accuracy: The high_distance_accuracy of this ReactIntoFeaturesRequest.  # noqa: E501
        :type high_distance_accuracy: bool
        """

        self._high_distance_accuracy = high_distance_accuracy

    @property
    def use_case_weights(self):
        """Gets the use_case_weights of this ReactIntoFeaturesRequest.  # noqa: E501

        If set to True will scale influence weights by each case's `weight_feature` weight.  # noqa: E501

        :return: The use_case_weights of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: bool
        """
        return self._use_case_weights

    @use_case_weights.setter
    def use_case_weights(self, use_case_weights):
        """Sets the use_case_weights of this ReactIntoFeaturesRequest.

        If set to True will scale influence weights by each case's `weight_feature` weight.  # noqa: E501

        :param use_case_weights: The use_case_weights of this ReactIntoFeaturesRequest.  # noqa: E501
        :type use_case_weights: bool
        """

        self._use_case_weights = use_case_weights

    @property
    def weight_feature(self):
        """Gets the weight_feature of this ReactIntoFeaturesRequest.  # noqa: E501

        The name of the feature whose values to use as case weights. When left unspecified, uses the internally managed case weight.   # noqa: E501

        :return: The weight_feature of this ReactIntoFeaturesRequest.  # noqa: E501
        :rtype: str
        """
        return self._weight_feature

    @weight_feature.setter
    def weight_feature(self, weight_feature):
        """Sets the weight_feature of this ReactIntoFeaturesRequest.

        The name of the feature whose values to use as case weights. When left unspecified, uses the internally managed case weight.   # noqa: E501

        :param weight_feature: The weight_feature of this ReactIntoFeaturesRequest.  # noqa: E501
        :type weight_feature: str
        """

        self._weight_feature = weight_feature

    def to_dict(self, serialize=False, exclude_null=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                elif 'exclude_null' in args:
                    return x.to_dict(serialize, exclude_null)
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            elif value is None and (exclude_null or attr not in self.nullable_attributes):
                continue
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReactIntoFeaturesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ReactIntoFeaturesRequest):
            return True

        return self.to_dict() != other.to_dict()
